/* dyn_strings.c
 * SommerCampus 2006
 * Author: Pablo Yanez Trujillo <yanezp@informatik.uni-freiburg.de>
 * License: GPL-2 */

#include <stdlib.h> 
#include <string.h>
#include <stdio.h>
#include <ctype.h> /* fr int toupper(int c); */

char *str_to_dyn_str(const char* src)
{
	size_t len;
	char *dest;

	len = strlen(src);

	dest = malloc(len + 1);

	if(!dest)
		return NULL;

	strcpy(dest, src); /* \0 von strcpy gesetzt */
	
	return dest;
}

int main(int argc, char ** argv)
{
	char *first;
	size_t i,len;

	if(argc != 2)
	{
		printf("usage: %s something\n", argv[0]);
		return 1;
	}

	first = str_to_dyn_str(argv[1]);

	if(!first)
	{
		printf("no memory left!\n");
		return 1;
	}

	len = strlen(first);

	for(i = 0; i < len; ++i)
		first[i] = toupper(first[i]);

	printf("first = %s\n", first);

	free(first); /* nicht vergessen ! */

	return 0;
}
